PGOBLIN_BANG(-f)
  Copyright (C)2022 @BABOLO http://www.babolo.ru/
  pkg = lrwi-textcase
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: lrwi-textcase.pgoblin.m4,v 1.8 2022/10/09 18:51:27 babolo Exp $

#echo    Q
##Q copy E
##q copy
#style   00Q00Q
Q
#style   00Q00q
q
#job
local -zz
#connect 0002
sqlite3 CIPALITEVAR/BASE.sqlite
#perform 0002
PRAGMA foreign_keys = 1;
#perform 0002
PRAGMA temp_store = 2;
#perform 0002
PRAGMA application_id = 0x43495041;
#perform 0002  #######################################################      ####
CREATE TEMP TABLE v(v real) STRICT;
#cat     _
PREFIX/include/babolo/PKG.VERSION
#trap
#echo
@@@Ignore it

#perform 0002
INSERT INTO v VALUES(NULL);
#return
#copyin  00_2
COPY v;
#untrap
#wait
#close   _0_
#select  0002
SELECT 'PKG'
     , '=VERS'
     , ' File=' || CAST(v.v AS TEXT)
     , (SELECT ' DB=' || CAST(SQNM(version).SQAT(major) AS TEXT) || '.' || SQNM(version).SQAT(minor)
         FROM SQNM(version)
         WHERE SQNM(version).SQAT(pkg) == 'PKG' AND SQNM(version).SQAT(protover) IS NULL
        LIMIT 1
       )
     , ' %%%%%%%%%%%%%%%%
'FROM v CROSS JOIN SQNM(version)
 WHERE SQNM(version).SQAT(pkg) == 'PKG'
   AND COALESCE(SQNM(version).SQAT(protover) == NULLIF('PROTOVER', ''), 1)
;
#perform 0002  ##################################################################     ####
CREATE TABLE IF NOT EXISTS SQNM(attr)                   --  
     ( SQAT(attr)  INTEGER PRIMARY KEY AUTOINCREMENT      -- 
     , SQAT(name)  text    NOT NULL                       -- 
     , SQAT(nome)  text    NOT NULL                       -- "" 
     , SQAT(ordr)  int                                    -- 
     ) STRICT
;
#perform 0002
CREATE TEMP TABLE SQNM(tmpattr)                         --  
     ( SQAT(attr)  INTEGER PRIMARY KEY AUTOINCREMENT      -- 
     , SQAT(name)  text    NOT NULL                       -- 
     , SQAT(nome)  text    NOT NULL                       -- "" 
     , SQAT(ordr)  int                                    -- 
     ) STRICT
;
#perform 0002
INSERT INTO SQNM(tmpattr)
 VALUES (1, ''              , ' '                  , 1)
      , (2, ''                 , ' '                  , 2)
      , (3, ''             , ' '               , 3)
      , (4, ''           , ' '              , 4)
      , (5, ''              , ' '                 , 5)
      , (6, '  ', '   ', 6)
;
#select  _002
DELETE FROM SQNM(attr)
 WHERE SQAT(attr) NOT IN(SELECT SQAT(attr) FROM SQNM(tmpattr))
 RETURNING  '-attr', *
;
#display 00_00q
#select  _002
UPDATE SQNM(attr)
   SET SQAT(name) = SQNM(tmpattr).SQAT(name)
     , SQAT(nome) = SQNM(tmpattr).SQAT(nome)
     , SQAT(ordr) = SQNM(tmpattr).SQAT(ordr)
 FROM SQNM(tmpattr)
 WHERE SQNM(attr).SQAT(attr) == SQNM(tmpattr).SQAT(attr)
   AND SQNM(attr).SQAT(name) IS NOT SQNM(tmpattr).SQAT(name)
   AND SQNM(attr).SQAT(nome) IS NOT SQNM(tmpattr).SQAT(nome)
   AND SQNM(attr).SQAT(ordr) IS NOT SQNM(tmpattr).SQAT(ordr)
 RETURNING  '~attr', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(attr) SELECT * FROM SQNM(tmpattr) RETURNING  '+attr', *;
#display 00_00q
#perform 0002  ##############################################################     ####
CREATE TABLE IF NOT EXISTS SQNM(vale)                   --  
     ( SQAT(attr)  int                                    --   
     , SQAT(vale)  int                                    --   
     , SQAT(name)  text    NOT NULL                       -- 
     , SQAT(ordr)  int                                    -- 
     , PRIMARY KEY(SQAT(attr), SQAT(vale))
     ) STRICT
;
#perform 0002  ##################################################################     ####
CREATE TABLE IF NOT EXISTS SQNM(part)                   --  
     ( SQAT(part)  INTEGER PRIMARY KEY AUTOINCREMENT      -- 
     , SQAT(name)  text                                   -- 
     ) STRICT
;
#perform 0002
CREATE TEMP TABLE SQNM(tmppart)                         --  
     ( SQAT(part)  INTEGER PRIMARY KEY AUTOINCREMENT      -- 
     , SQAT(name)  text                                   -- 
     ) STRICT
;
#perform 0002
INSERT INTO SQNM(tmppart)(SQAT(part), SQAT(name))
 VALUES ( 1, NULL                         )
      , ( 2, '   ')
      , ( 3, '  '          )
      , ( 4, ''                    )
      , ( 5, ''                    )
      , ( 6, ''                  )
;
#begin   0002
#select  _002
DELETE FROM SQNM(part)
 WHERE SQAT(part) NOT IN (SELECT SQNM(tmppart).SQAT(part) FROM SQNM(tmppart))
 RETURNING '-part', *
;
#display 00_00q
#select  _002
UPDATE SQNM(part)
   SET SQAT(name) = SQNM(tmppart).SQAT(name)
 FROM SQNM(tmppart)
 WHERE SQNM(tmppart).SQAT(part) == SQNM(part).SQAT(part)
   AND SQNM(tmppart).SQAT(name) IS NOT SQNM(part).SQAT(name)
 RETURNING '~part', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(part) SELECT * FROM SQNM(tmppart) RETURNING '+part', *;
#display 00_00q
#end     0002
#perform 0002  ###################################################################    ####
CREATE TABLE IF NOT EXISTS SQNM(demo)                   --  
     ( SQAT(demo)  INTEGER PRIMARY KEY AUTOINCREMENT      -- 
     , SQAT(exec)  text    NOT NULL                       -- 
     ) STRICT
;
#perform 0002  ##########################################################################    ####
CREATE TABLE IF NOT EXISTS SQNM(text)                          --  
     ( SQAT(text)  INTEGER PRIMARY KEY AUTOINCREMENT             -- 
     , SQAT(head)  text NOT NULL                                 -- 
     , SQAT(sub)   text                                          -- 
     , SQAT(levl)  int  NOT NULL                                 --   
     , SQAT(ordr)  int  DEFAULT 999                              -- 
     , SQAT(demo)  int  NOT NULL REFERENCES SQNM(demo) DEFAULT 0 --  
     , SQAT(parm)  int                                           --  
     ) STRICT
;
#perform 0002  ###############################################################   X   ####
CREATE TABLE IF NOT EXISTS SQNM(textattr)               --  
     ( SQAT(text)  int     NOT NULL REFERENCES SQNM(text) --   
     , SQAT(attr)  int     NOT NULL REFERENCES SQNM(attr) --    
     , SQAT(vale)  int     NOT NULL                       --    
     , SQAT(ordr)  int                                    -- 
     , PRIMARY KEY(SQAT(text), SQAT(attr), SQAT(vale))
     , FOREIGN KEY(SQAT(attr), SQAT(vale)) REFERENCES SQNM(vale)
     ) STRICT
;
#perform 0002  ##############################################################   X   ####
CREATE TABLE IF NOT EXISTS SQNM(textpart)               --  
     ( SQAT(text)  int     NOT NULL REFERENCES SQNM(text) --   
     , SQAT(part)  int     NOT NULL REFERENCES SQNM(part) --    
     , SQAT(lede)  int     NOT NULL REFERENCES SQNM(lede) --   
     , SQAT(ordr)  int                                    -- 
     , PRIMARY KEY(SQAT(text), SQAT(part), SQAT(lede))
     ) STRICT
#perform 0002  #################################################################    ####
CREATE VIEW IF NOT EXISTS SQNM(listattr) AS
 SELECT SQAT(text) AS SQAT(text), 1 AS SQAT(attr), SQAT(levl) AS SQAT(vale), SQAT(ordr) AS SQAT(ordr)
  FROM SQNM(text)
UNION
 SELECT SQAT(text)                                                 AS SQAT(text)
      , SQAT(attr)                                                 AS SQAT(attr)
      , SQAT(vale)                                                 AS SQAT(vale)
      , COALESCE(SQNM(textattr).SQAT(ordr), SQNM(text).SQAT(ordr)) AS SQAT(ordr)
  FROM SQNM(textattr) JOIN SQNM(text) USING(SQAT(text))
UNION
 SELECT SQNM(textpart).SQAT(text)                                  AS SQAT(text)
      , 6                                                          AS SQAT(attr)
      , SQNM(textpart).SQAT(lede)                                  AS SQAT(vale)
      , COALESCE(SQNM(lede).SQAT(ordr), SQNM(textpart).SQAT(ordr)) AS SQAT(ordr)
  FROM SQNM(textpart) JOIN SQNM(lede) USING(SQAT(lede))
  WHERE SQAT(part) IN(1, 2, 3, 5, 6)
;
#perform 0002  ##################################################################    ####
CREATE VIEW IF NOT EXISTS SQNM(listvale) AS
 SELECT SQAT(attr) AS SQAT(attr)
      , SQAT(vale) AS SQAT(vale)
      , SQAT(name) AS SQAT(name)
      , SQAT(ordr) AS SQAT(ordr)
  FROM SQNM(vale)
UNION
 SELECT 6                     AS SQAT(attr)
      , SQNM(lede).SQAT(lede) AS SQAT(vale)
      , SQNM(lede).SQAT(lf)
      || COALESCE(  ' '
                 || substr(SQNM(lede).SQAT(li), 1, 1)
                 || '.'
                 || COALESCE(' ' || substr(SQNM(lede).SQAT(lo), 1, 1) || '.', '')
                 , ''
                 )            AS SQAT(name)
      , SQNM(lede).SQAT(ordr) AS SQAT(ordr)
  FROM SQNM(lede)
;
#perform 0002  ##################################################################    ####
CREATE VIEW IF NOT EXISTS SQNM(fullattr) AS
 SELECT SQNM(atll).SQAT(text) AS SQAT(text)
      , group_concat(' ' || SQNM(attr).SQAT(name) || ': ' || SQNM(atll).SQAT(atll) || '.'
                    , ''
                    )         AS SQAT(attr)
  FROM (SELECT SQAT(text)                                AS SQAT(text)
             , SQAT(attr)                                AS SQAT(attr)
             , group_concat(SQNM(vale).SQAT(name), ', ') AS SQAT(atll)
         FROM  SQNM(textattr)
          JOIN SQNM(vale) USING(SQAT(attr), SQAT(vale))
         GROUP BY SQAT(text), SQAT(attr)
       )SQNM(atll)
   JOIN SQNM(attr) USING(SQAT(attr))
  WHERE SQAT(attr) IN(2, 3, 4, 5)
 GROUP BY SQNM(atll).SQAT(text)
;
#select  _002  ######################################################################   ####
UPDATE SQNM(proj)
   SET SQAT(name) = ''
     , SQAT(ordr) = 999
     , SQAT(vizi) = 1
     , SQAT(pnam) = 'lrwi-textcase'
 WHERE SQAT(proj) == LRWINUM
   AND (  SQAT(name) IS NOT ''
       OR SQAT(ordr) IS NOT 999
       OR SQAT(vizi) IS NOT 1
       OR SQAT(pnam) IS NOT 'lrwi-textcase'
       )
 RETURNING '~proj', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(proj)
 SELECT LRWINUM, '', 999, 1, 'lrwi-textcase'
 RETURNING '+proj', *
#display 00_00q
